#include "LIB_ICS.h"

/**
 * SPI_Init: This function sets up the SCI baud rate and mode.
 *
 * Parameters:      none
 *
 * Subfunctions:    none.
 *
 * Return:          void
 */ 
void ICS_FEE_32K768_8M388608(void) 
{
  ICSC2 = FRE_RANGE_LOW | CONFIG_LOW_POWER | EXT_OSC;
  
  //ICSC2_RANGE = 0x0;
  //ICSC2_HGO   = 0x1;
  //ICSC2_EREFS = 0x1;
  
  ICSC1 = CLKS_FLL | EXT_REF;
  
  //ICSC1_CLKS  = 0;
  //ICSC1_IREFS = 0;
  //ICSC1_RDIV  = 0;
    
  while (!ICSSC_OSCINIT);
  
  while (ICSSC_CLKST);	
  
  ICSC2_BDIV  = 0;
}

void ICS_FEE_2M4576_9M8304(void) 
{
  ICSC2 = FRE_RANGE_HIGH | CONFIG_LOW_POWER | EXT_CLK;
  //ICSC2_RANGE = 0x1;
  //ICSC2_HGO   = 0x0;
  //ICSC2_EREFS = 0x0;
  
  ICSC1 = CLKS_FLL | EXT_REF | (6 << 3);
  //ICSC1_CLKS  = 0;
  //ICSC1_IREFS = 0;
  //ICSC1_RDIV  = 6;
  
  while (ICSSC_CLKST);
  	
  ICSC2_BDIV  = 0;	
} 

void ICS_FEE_4M_8M(void) 
{
  ICSC2 = FRE_RANGE_HIGH | CONFIG_LOW_POWER | EXT_CLK;
  //ICSC2_RANGE = 0x1;
  //ICSC2_HGO   = 0x0;
  //ICSC2_EREFS = 0x0;
  
  ICSC1 = CLKS_FLL | EXT_REF | (7 << 3);
  //ICSC1_CLKS  = 0;
  //ICSC1_IREFS = 0;
  //ICSC1_RDIV  = 7;
  
  while (ICSSC_CLKST);
  	
  ICSC2_BDIV  = 0;	
}

void ICS_FBE_4M_2M(void) 
{
  ICSC2 = FRE_RANGE_HIGH | CONFIG_LOW_POWER | EXT_CLK;
  //ICSC2_RANGE = 0x1;
  //ICSC2_HGO   = 0x0;
  //ICSC2_EREFS = 0x0;
  
  ICSC1_CLKS  = 0x2;
  
  while (ICSSC_CLKST != 2);
  	
  ICSC2_BDIV  = 0;	
} 

void ICS_FBE_32K768_16K384(void) 
{
  ICSC2 = FRE_RANGE_LOW | CONFIG_LOW_POWER | EXT_OSC;
  //ICSC2_RANGE = 0x0;
  //ICSC2_HGO   = 0x1;
  //ICSC2_EREFS = 0x1;
  
  ICSC1_CLKS  = 0x2;
  
  while (!ICSSC_OSCINIT);
  
  while (ICSSC_CLKST != 2);
  	
  ICSC2_BDIV  = 0;	
} 

void ICS_FEI_10M(void) 
{
  ICSC1 = CLKS_FLL | INT_REF;
  
  //ICSC1_CLKS  = 0;
  //ICSC1_IREFS = 1;
  //ICSC1_RDIV  = 0;
  
  while (ICSSC_CLKST);
  
  ICSC2_BDIV  = 0;
  ICSTRM      = 0x68;
}

void ICS_FEI_8M(void) 
{
  ICSC1 = CLKS_FLL | INT_REF;
  
  //ICSC1_CLKS  = 0;
  //ICSC1_IREFS = 1;
  //ICSC1_RDIV  = 0;
  
  while (ICSSC_CLKST);
  
  if (NVICSTRM != 0xFF)
    ICSTRM = NVICSTRM;
  else
    ICSTRM = 0x80;
  
  ICSC2_BDIV  = 0;

}

void ICS_FEI_4M(void) 
{
  ICSC1 = CLKS_FLL | INT_REF;
  
  //ICSC1_CLKS  = 0;
  //ICSC1_IREFS = 1;
  //ICSC1_RDIV  = 0;
  
  while (ICSSC_CLKST);
  
  if (NVICSTRM != 0xFF)
    ICSTRM = NVICSTRM;
  else
    ICSTRM = 0x80;
  
  ICSC2_BDIV  = 1;
}

void ICS_FEI_2M(void) 
{
  ICSC1 = CLKS_FLL | INT_REF;
  //ICSC1_CLKS  = 0;
  //ICSC1_IREFS = 1;
  //ICSC1_RDIV  = 0;
  
  while (ICSSC_CLKST);
  if (NVICSTRM != 0xFF)
    ICSTRM = NVICSTRM;
  else
    ICSTRM = 0x80;
  
  ICSC2_BDIV  = 2;
}

void ICS_FEI_1M(void) 
{
  ICSC1 = CLKS_FLL | INT_REF;
  //ICSC1_CLKS  = 0;
  //ICSC1_IREFS = 1;
  //ICSC1_RDIV  = 0;
  
  while (ICSSC_CLKST);
  if (NVICSTRM != 0xFF)
    ICSTRM = NVICSTRM;
  else
    ICSTRM = 0x80;
  
  ICSC2_BDIV  = 3;
}

void ICS_FBI(void) 
{
  ICSC1_IREFS = 1;
  ICSC1_CLKS  = 0x1;
  
  while (ICSC1_CLKS != 1);
  
  if (NVICSTRM != 0xFF)
    ICSTRM = NVICSTRM;
  else
    ICSTRM = 0x80;
  	
  ICSC2_BDIV  = 0;

}












